#pragma once

#include <dshow.h>

// guidɓĂȂǉGUID
#ifndef WAVE_FORMAT_AAC
#define WAVE_FORMAT_AAC 0x00FF
#endif
#ifndef MEDIASUBTYPE_AAC
DEFINE_GUID(MEDIASUBTYPE_AAC,WAVE_FORMAT_AAC, 0x000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);
#endif

class CDirectShowUtil
{
public:
	CDirectShowUtil(void);
	~CDirectShowUtil(void);

	void Clear();
	bool FindFilter(const CLSID *pidInType,const CLSID *pidInSubType,const CLSID *pidOutType=NULL,const CLSID *pidOutubType=NULL);
	int GetFilterCount();
	bool GetFilterInfo(const int iIndex,CLSID *pidClass=NULL,CStringW *pFriendryName=NULL);
	
	// ֗֐
	static IPin* GetFilterPin(IBaseFilter *pFilter,const PIN_DIRECTION dir,const AM_MEDIA_TYPE *pMediaType);

protected:
	struct DIRECTSHOW_FILTER_INFO {
		CStringW	friendry_name;
		CLSID		class_id;
	};
	CArray<DIRECTSHOW_FILTER_INFO> m_FilterClassID;
};
